// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "asset/AssetLoader.hpp"
#include "asset/AssetDataLoader.hpp"


namespace Dawn {
  enum class JSONLoaderState {
    INITIAL,
    LOADING_JSON,
    DONE
  };

  class JSONLoader : public AssetLoader {
    protected:
      AssetDataLoader loader;
      enum JSONLoaderState state;

    public:
      const static std::string ASSET_TYPE;

      json data;

      JSONLoader(
        const std::shared_ptr<AssetManager> assetManager,
        const std::string name
      );
      void updateSync() override;
      void updateAsync() override;
      std::string getAssetType() const override;
      ~JSONLoader();
  };
}