// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "SceneComponentRegistry.hpp"


using namespace Dawn;

std::unordered_map<
  std::string,
  std::function<std::shared_ptr<SceneComponent>(
    const std::shared_ptr<SceneItem> &
  )>
> SceneComponentRegistry::REGISTRY = {
  
};

std::shared_ptr<SceneComponent> SceneComponentRegistry::createComponent(
  const std::string &type,
  const std::shared_ptr<SceneItem> &item
) {
  auto typeLower = String::toLowercase(type);
  assertMapHasKey(
    SceneComponentRegistry::REGISTRY,
    typeLower,
    "Component type not registered: %s",
    type.c_str()
  );

  return SceneComponentRegistry::REGISTRY[typeLower](item);
}