// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/mesh/Mesh.hpp"

#define CUBE_VERTICE_COUNT 8
#define CUBE_INDICE_COUNT 36

namespace Dawn {
  class CubeMesh {
    public:
      /**
       * Buffers cube mesh vertices and indices into the given mesh.
       * 
       * @param size The size of the cube.
       * @param verticeStart The starting index of the vertices.
       * @param indiceStart The starting index of the indices.
       */
      static void buffer(
        const std::shared_ptr<Mesh> mesh,
        const glm::vec3 pos,
        const glm::vec3 size,
        const int32_t verticeStart,
        const int32_t indiceStart
      );
  };
}