// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawn.hpp"

/**
 * Asserts that there are no OpenGL errors.
 * 
 * @param file The file the assertion is being made in.
 * @param line The line the assertion is being made in.
 */
void assertNotGLErrorCheck(const char *file, int32_t line);

/**
 * Asserts that there are no OpenGL errors.
 */
#define assertNoGLError() assertNotGLErrorCheck(__FILE__, __LINE__) 